(*	Ce fichier contient 
	->	La version fausse programmation
	->	La version affichage texte
	->	La version programmation							
	
			la version graphique n'est pas ici				*)	

(**)
				(* Lions et clowns : version fausse programmation *)

let nb_lion=3;;let nb_clown=3;;let nb_place=3;;
let terrain=[|0;nb_lion;nb_clown;0;0;0;0;0;0|];;	(* le 0 initial pour avoir des emplacements 1..8 *)

(* la fonction TG effectue un Transbordement Gauche de l lions et de c clowns depuis BG vers FG
	quand l >0 c'est BG -> FG quand l < 0 c'est BG <- FG (de mme pour c)	*)

let TG l c = 
	if  l > terrain.(1) then failwith "erreur TG B l" else
	if  c > terrain.(2) then failwith "erreur TG B c" else
	if  -l > terrain.(3) then failwith "erreur TG F l" else
	if  -c > terrain.(4) then failwith "erreur TG F c" else
	terrain.(1)<-terrain.(1)-l; 
	terrain.(3)<-terrain.(3)+l;
	terrain.(2)<-terrain.(2)-c; 
	terrain.(4)<-terrain.(4)+c;;

(* la fonction Traverse dplace la barque : on echange les emplacements 3,5 et 4,6	*)

let T() =  let old3=terrain.(3) and old4=terrain.(4) 	
	in 	terrain.(3)<-terrain.(5); 	terrain.(4)<-terrain.(6); 
		terrain.(5)<-old3; terrain.(6)<-old4;;

(* la fonction TD effectue un Transbordement Droit de l lions et de c clowns depuis FD vers BD
	quand l >0 c'est FD -> BD quand l < 0 c'est FD <- BD (de mme pour c)	*)

let TD l c = 
	if  l > terrain.(5) then failwith "erreur TD F l" else
	if  c > terrain.(6) then failwith "erreur TD F c" else
	if  -l > terrain.(7) then failwith "erreur TD B l" else
	if  -c > terrain.(8) then failwith "erreur TD B c" else
	terrain.(5)<-terrain.(5)-l; 
	terrain.(7)<-terrain.(7)+l;
	terrain.(6)<-terrain.(6)-c; 
	terrain.(8)<-terrain.(8)+c;;


(**)
				(* Lions et clowns : version affichage texte *)

let s_o_v()=[|"";make_string (terrain.(1)) `L`;make_string (terrain.(2)) `C`;make_string (terrain.(3)) `L`;
make_string (terrain.(4)) `C`; make_string (terrain.(5)) `L`;make_string (terrain.(6)) `C`;make_string (terrain.(7)) `L`;make_string (terrain.(8)) `C`|];;

let affiche()=print_string"[ ";print_string ((s_o_v()).(1));print_string ((s_o_v()).(2)); print_string" ]";
if terrain.(3)<>0 or terrain.(4)<>0 
then begin print_string"\ ";print_string ((s_o_v()).(3));print_string ((s_o_v()).(4)); print_string"/" end
else  print_string "          ";
if terrain.(5)<>0 or terrain.(6)<>0 
then begin print_string"\ ";print_string ((s_o_v()).(5));print_string ((s_o_v()).(6)); print_string"/" end
else  print_string "          ";
print_string"[ ";print_string ((s_o_v()).(7));print_string ((s_o_v()).(8)); print_string" ]";
print_newline();;

(* si on excute les lignes qui suivent, on voit s'afficher tous les tats successifs *)
	
TG 1 1;; affiche();; T() ;; affiche();; 
TD 1 0 ;; affiche();; T() ;; affiche();; 
TG 1 1 ;; affiche();; T() ;; affiche();; 
TD 0 1 ;;  affiche();; T() ;; affiche();; 
TG 0 1;; affiche();; T() ;; affiche();; 
TD 1 1 ;; affiche();; T() ;; affiche();; 
TG 1 0 ;; affiche();; T() ;; affiche();; 
TD 1 1 ;;  affiche();; T() ;; affiche();; 



(**)
				(* Lions et clowns : version programmation *)

let nb_lion=3;;let nb_clown=3;;let nb_place=3;;

(* let nb_lion=4;;let nb_clown=4;;let nb_place=3;;	*)

let terrain=[|0;nb_lion;nb_clown;0;0;0;0;0;0|];;
let E_ini=[];; let T_ini=terrain;;
let perdu x= x=[] ;;
let gagne x = mem [|0;0;0;0;0;0;0;nb_lion;nb_clown|] x ;;

(* voisinsG donne la liste des voisins d'un tat de Gauche, la barque est vide, on sait qu'il y a au moins un clown : c'est le cas pour l'tat initial et ce sera le cas par rcurrence  chaque retour de la barque *)

let voisinsG liste = 
	let lbg=liste.(1) and cbg=liste.(2) and lbd=liste.(7) and cbd=liste.(8) and 
	envoi=ref [] in 
	begin
		if (((cbg=1) or (cbg-1>=lbg)) & (cbd+1>=lbd)) 
			then envoi := [|0;lbg;cbg-1;0;0;0;0;lbd;cbd+1|]::!envoi; 
		if (((cbg=2) or (cbg-2>=lbg)) & (cbd+2>=lbd)) 
			then envoi := [|0;lbg;cbg-2;0;0;0;0;lbd;cbd+2|]::!envoi; 
		if (((cbg=3) or (cbg-3>=lbg)) & (cbd+3>=lbd)) 
			then envoi := [|0;lbg;cbg-3;0;0;0;0;lbd;cbd+3|]::!envoi; 
		if ((cbg>=1) & (lbg>=1) & (lbd<=cbd)) 
			then envoi := [|0;lbg-1;cbg-1;0;0;0;0;lbd+1;cbd+1|]::!envoi; 
		if ((cbg>=2) & (lbg>=1) & (cbg-2>=lbg-1) & (cbd+2>=lbd+1)) 
			then envoi := [|0;lbg-1;cbg-2;0;0;0;0;lbd+1;cbd+2|]::!envoi; 
	end;
	!envoi;;

let voisinsD liste = 
	let lbg=liste.(1) and cbg=liste.(2) and lbd=liste.(7) and cbd=liste.(8) and 
	envoi=ref [] in 
	begin
		if (((cbd=1) or (cbd-1>=lbd)) & (cbg+1>=lbg)) 
			then envoi := [|0;lbg;cbg+1;0;0;0;0;lbd;cbd-1|]::!envoi; 
		if (((cbd=2) or (cbd-2>=lbd)) & (cbg+2>=lbg)) 
			then envoi := [|0;lbg;cbg+2;0;0;0;0;lbd;cbd-2|]::!envoi; 
		if (((cbd=3) or (cbd-3>=lbd)) & (cbg+3>=lbg)) 
			then envoi := [|0;lbg;cbg+3;0;0;0;0;lbd;cbd-3|]::!envoi; 
		if ((cbd>=1) & (lbd>=1) & (lbg<=cbg)) 
			then envoi := [|0;lbg+1;cbg+1;0;0;0;0;lbd-1;cbd-1|]::!envoi; 
		if ((cbd>=2) & (lbd>=1) & (cbd-2>=lbd-1) & (cbg+2>=lbg+1)) 
			then envoi := [|0;lbg+1;cbg+2;0;0;0;0;lbd-1;cbd-2|]::!envoi; 
	end;
	!envoi;;

(* a semble marcher	
 [voisinsD [|0; 2; 2; 0; 0; 0; 0; 1; 1|];;	 [[|0; 3; 3; 0; 0; 0; 0; 0; 0|]; [|0; 2; 3; 0; 0; 0; 0; 1; 0|]]	*)
	
(* pour programmer ce qui reste  faire il y a plein d'ennuis!!!!
	->	la bonne structure pour insrer, retirer ... c'est l'arbre (pas encore vu)
	->	comme vous avez vu des listes en sup on peut s'en servir, mais comm on est arriv ici avec des vecteurs on ne peut comparer sympathiquement : 

let rec lexico = fun
	|[] _			->	true
	|_ []			->	false
	|(ta::qa) (tb::qb)	->	(ta<tb) or (ta=tb & (lexico qa qb));;		

	tout cela amne  crire la trs vilaine fonction qui suit    *)

let lexico_vec va vb=
	(va.(1)<vb.(1))
 or 	((va.(1)=vb.(1)) &   ((va.(2)<vb.(2)) 
				or ((va.(2)=vb.(2)) & ((va.(7)<vb.(7)) or
							    ((va.(7)=vb.(7)) & (va.(8)<=vb.(8))
))))) ;;

(* comment tre sr d'une telle fonction ??? *)					

#open"sort";;
let insere l1 l2=
	let rec jette_doublon = function
		|[]	->	[]
		|[a]	->	[a]
		|a::b::q->	if a=b then jette_doublon (b::q) else a::(jette_doublon (b::q))
	in jette_doublon (sort lexico_vec (l1@l2));;

let rec voisinsG_liste  = function
	|[]		->	[]
	|t::q		->	insere (voisinsG t) (voisinsG_liste q);;

let rec voisinsD_liste  = function
	|[]		->	[]
	|t::q		->	insere (voisinsD t) (voisinsD_liste q);;

(* retire enlve de liste2 ceux dja dans liste1 (listes supposes tries *)
let rec enleve = fun
	|[] x			->	x
	|_ []			->	[]
	|(t1::q1) (t2::q2)		->	if t2<t1 
					then t2::(enleve (t1::q1) q2)
					else	if t1=t2
						then  (enleve (t1::q1) q2)
						else 	(enleve q1 (t2::q2))
;;

(* enleve (sort (prefix <) [2;4;6;8;10;7]) (sort (prefix <) [8;6;4;7;5;1;2;3;4;5;7;8;9]);;
- : int list = [1; 3; 5; 5; 9]											*)

(* aprs le premier voisinsG T_ini on initialise E  [] et et on ne fera que des aller-retour *)

let suivant (E,T) = 
	if perdu T then failwith "c'tait impossible"
	else	if gagne T then failwith "c'est gagn"
		else 	let e1= insere E T
			in	let vois1= voisinsD_liste T
				in 	let vois2 = (enleve e1 (voisinsG_liste vois1))
					in (e1,vois2);;

let (e1,t1)=([],voisinsG terrain);;
let (e2,t2)=suivant (e1,t1);;
let (e3,t3)=suivant (e2,t2);;
let (e4,t4)=suivant (e3,t3);;
let (e5,t5)=suivant (e4,t4);;

(* liste d'erreurs : 
-	j'avais oubli un cas dans voisinsD et voisinsG (le 3-ime test du 4-ime cas)
-	je n'avais pas bien vu que E ne concernait que les tats de la berge droite : ma fonction "suivant" tait fausse													*) 